<template>
  <ele-modal
    custom-class="ele-dialog-form long-dialog-form"
    :centered="true"
    v-if="visible"
    :visible.sync="visible"
    :close-on-click-modal="false"
    :append-to-body="true"
    width="70%"
    @close="cancel"
    :maxable="true"
    :resizable="true"
    :title="title"
  >
    <el-form
      ref="form"
      :model="form"
      :rules="rules"
      label-width="120px"
      class="el-form-box"
    >
      <headerTitle title="订单信息"></headerTitle>
      <el-row>
        <el-col :span="12">
          <el-form-item label="项目名称" prop="projectName">
            <el-input
              clearable
              v-model="form.projectName"
              @clear="clearContrcat"
              placeholder="请输入"
              style="width: calc(100% - 80px)"
            />
            <el-button
              style="margin-left: 5px"
              size="small"
              type="primary"
              @click.native="handleProjectBtn"
              >选择
            </el-button>
          </el-form-item>
          <el-form-item label="销售类型" prop="saleType">
            <DictSelection
              dictName="销售类型"
              clearable
              v-model="form.saleType"
              :listFormatte="listFormatte"
            >
            </DictSelection>
          </el-form-item>

          <el-form-item label="销售部门" prop="salesDeptId">
            <ele-tree-select
              clearable
              :data="groupTreeData"
              v-model="form.salesDeptId"
              valueKey="id"
              labelKey="name"
              placeholder="请选择"
              @change="change_principalDep"
              default-expand-all
            />
          </el-form-item>
          <el-form-item label="订单类型" prop="needProduce">
            <el-radio v-model="form.needProduce" :label="1"
              >有客户生产性订单</el-radio
            >
            <el-radio v-model="form.needProduce" :label="0"
              >库存式订单</el-radio
            >
            <el-radio v-model="form.needProduce" :label="2"
              >无客户生产性订单</el-radio
            >
            <el-radio
              v-model="form.needProduce"
              :label="4"
              @change="needProduceChange"
              v-if="clientEnvironmentId != 5"
              >不定向订单</el-radio
            >
          </el-form-item>
          <el-form-item prop="orderFiles" label="订单附件">
            <fileMain v-model="form.orderFiles"></fileMain>
          </el-form-item>
        </el-col>

        <el-col :span="12">
          <el-form-item label="选择合同" prop="contractName">
            <el-input
              clearable
              v-model="form.contractName"
              @click.native="handleContractBtn"
              @clear="clearContrcat"
              placeholder="请选择"
              :disabled="!!projectData.contractId"
            />
          </el-form-item>
          <el-form-item label="合同编号" prop="contractNumber">
            <el-input disabled v-model="form.contractNumber" />
          </el-form-item>

          <el-form-item label="结算方式" prop="settlementMode">
            <DictSelection
              dictName="结算方式"
              clearable
              @itemChange="settlementModeChange"
              v-model="form.settlementMode"
            >
            </DictSelection>
          </el-form-item>
          <el-form-item
            label="总数"
            prop="totalPlanNum"
            v-if="form.needProduce == 4"
          >
            <el-input v-model="form.totalPlanNum" class="totalPlanNum">
              <template slot="append">
                <DictSelection
                  dictName="计量单位"
                  clearable
                  v-model="form.planNumUnit"
                >
                </DictSelection>
              </template>
            </el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <headerTitle title="基本信息" v-if="form.needProduce != 2"></headerTitle>
      <el-row v-if="form.needProduce != 2">
        <el-col :span="12">
          <el-form-item label="客户名称" prop="partaName">
            <el-input
              clearable
              v-model="form.partaName"
              @click.native="handParent"
              placeholder="请选择"
              readonly
              :disabled="!!contactData?.id"
            />
          </el-form-item>
          <el-form-item
            label="客户统一社会信用代码"
            prop="partaUnifiedSocialCreditCode"
            class="form_item_label"
          >
            <el-input
              clearable
              v-model="form.partaUnifiedSocialCreditCode"
              placeholder="请输入"
            />
          </el-form-item>
          <el-form-item label="客户联系人" prop="partaLinkName">
            <el-select
              v-model="form.partaLinkName"
              placeholder="请选择"
              @change="onchangeLink"
              @focus="selectFocus"
              style="width: 100%"
            >
              <el-option
                v-for="item in linkNameOptions"
                :key="item.id"
                :label="item.linkName"
                :value="item.id"
              >
              </el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="客户电话" prop="partaTel">
            <el-input
              clearable
              :maxlength="20"
              v-model="form.partaTel"
              placeholder="请输入"
            />
          </el-form-item>
          <el-form-item label="客户传真" prop="partaFax">
            <el-input clearable v-model="form.partaFax" placeholder="请输入" />
          </el-form-item>
          <el-form-item label="	客户Email" prop="partaEmail">
            <el-input
              clearable
              v-model="form.partaEmail"
              placeholder="请输入"
            />
          </el-form-item>
          <el-form-item label="客户地址" prop="partaAddress">
            <el-input
              clearable
              v-model="form.partaAddress"
              placeholder="请输入"
            />
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="售出方名称" prop="partbName">
            <el-input
              v-if="enterprisePage.length <= 1"
              clearable
              v-model="form.partbName"
              placeholder="请输入"
            />
            <el-select
              v-if="enterprisePage.length > 1"
              style="width: 100%"
              v-model="form.partbName"
              placeholder="请选择"
              @change="getEnterprise()"
            >
              <el-option
                v-for="item in enterprisePage"
                :key="item.id"
                :label="item.name"
                :value="item.name"
              >
              </el-option>
            </el-select>
          </el-form-item>
          <el-form-item
            label="售出方统一社会信用代码"
            prop="partbUnifiedSocialCreditCode"
            class="form_item_label"
          >
            <el-input
              clearable
              v-model="form.partbUnifiedSocialCreditCode"
              placeholder="请输入"
            />
          </el-form-item>
          <el-form-item label="售出方联系人" prop="partbLinkName">
            <el-input
              clearable
              v-model="form.partbLinkName"
              @click.native="handHead"
              placeholder="请输入"
            />
          </el-form-item>
          <el-form-item prop="partbTel" label="售出方联系电话">
            <el-input clearable v-model="form.partbTel" placeholder="请输入" />
          </el-form-item>
          <el-form-item prop="partbFax" label="售出方传真">
            <el-input clearable v-model="form.partbFax" placeholder="请输入" />
          </el-form-item>

          <el-form-item label="售出方Email" prop="partbEmail">
            <el-input
              clearable
              v-model="form.partbEmail"
              placeholder="请输入"
            />
          </el-form-item>

          <el-form-item label="售出方地址" prop="partbAddress">
            <el-input
              clearable
              v-model="form.partbAddress"
              placeholder="请输入"
            />
          </el-form-item>
        </el-col>
      </el-row>

      <headerTitle
        title="物品清单"
        style="margin-top: 30px"
        v-if="form.needProduce != 4"
      ></headerTitle>
      <inventoryTable
        v-if="form.needProduce != 4"
        :customerMark="customerMark"
        :isCustomerMark="clientEnvironmentId != 4 && form.needProduce != 2"
        :isProduceDeliveryDeadline="form.needProduce != 0"
        ref="inventoryTable"
        @setCountAmount="setCountAmount"
        :isContractId="!!form.contractId"
        :isChangeCount="false"
        :needProduce="form.needProduce"
        :isSupplier="true"
        :isArrivalWay="true"
        :cacheKeyUrl="cacheKeyUrl"
      ></inventoryTable>
      <headerTitle
        title="类型清单"
        style="margin-top: 30px"
        v-if="form.needProduce == 4"
      ></headerTitle>

      <typeList
        v-if="form.needProduce == 4"
        @setCountAmount="setCountAmount"
        @setTotalPlanNum="setTotalPlanNum"
        ref="typeListRef"
      ></typeList>

      <el-row v-if="form.needProduce == 1">
        <el-col :span="8">
          <el-form-item
            label="自动生成采购计划："
            label-width="160px"
            prop="generatePurchase"
          >
            <el-radio-group v-model="form.generatePurchase">
              <el-radio :label="1">是</el-radio>
              <el-radio :label="0">否</el-radio>
            </el-radio-group>
          </el-form-item>
        </el-col>

        <el-col :span="8">
          <el-form-item
            label="自动生成生产计划："
            label-width="160px"
            prop="generateProduce"
          >
            <el-radio-group v-model="form.generateProduce">
              <el-radio :label="1">是</el-radio>
              <el-radio :label="0">否</el-radio>
            </el-radio-group>
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item
            label="自动生成项目立项："
            label-width="160px"
            prop="generateProject"
          >
            <el-radio-group v-model="form.generateProject">
              <el-radio :label="1">是</el-radio>
              <el-radio :label="0">否</el-radio>
            </el-radio-group>
          </el-form-item>
        </el-col>
      </el-row>
      <el-row style="margin-top: 20px">
        <el-col :span="12">
          <el-form-item label="总金额" prop="totalAmount">
            {{ form.totalAmount || 0 }}元
          </el-form-item>
          <el-form-item label="收货地址" prop="receiveAddress">
            <el-input
              clearable
              type="textarea"
              v-model="form.receiveAddress"
              placeholder="请输入"
            />
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="优惠后总金额">
            <el-input
              type="number"
              :min="0"
              :max="form.totalAmount"
              clearable
              :disabled="!!form.contractId || !form.totalAmount"
              v-model="form.payAmount"
              @input="discountInput"
              placeholder="请输入"
            >
              <template slot="append">元</template>
            </el-input>
          </el-form-item>
          <el-form-item label="备注" prop="remark">
            <el-input
              clearable
              type="textarea"
              v-model="form.remark"
              placeholder="请输入"
            />
          </el-form-item>
        </el-col>
      </el-row>
    </el-form>

    <div slot="footer" class="footer">
      <el-button type="primary" @click="save" v-click-once>保存</el-button>
      <el-button
        type="primary"
        v-if="isNeed_process_is_close"
        @click="save('sub')"
        v-click-once
        >提交</el-button
      >

      <el-button @click="cancel">返回</el-button>
    </div>

    <parentList ref="parentRef" @changeParent="changeParent"></parentList>
    <head-list ref="headRef" @changeParent="changePersonel"></head-list>
    <contractListDialog
      ref="selectContractRef"
      @changeParent="changeContract"
      :contactData="contactData"
    ></contractListDialog>
    <projectListDialog
      :contactData="contactData"
      ref="selectProjectRef"
      @changeParent="changeProject"
    ></projectListDialog>
    <process-submit-dialog
      :isNotNeedProcess="false"
      :processSubmitDialogFlag.sync="processSubmitDialogFlag"
      v-if="processSubmitDialogFlag"
      ref="processSubmitDialogRef"
      @reload="reload"
    ></process-submit-dialog>
  </ele-modal>
</template>

<script>
  import { emailReg, numberReg, telReg } from 'ele-admin';
  import inventoryTable from '@/BIZComponents/inventoryTable.vue';
  import fileUpload from '@/components/upload/fileUpload';
  import dictMixins from '@/mixins/dictMixins';
  import parentList from '@/views/saleManage/contact/components/parentList.vue';
  import {
    getDetail,
    updateContractStatus
  } from '@/api/contractManage/contractBook';
  import {
    contactDetail,
    updateRelationStatus
  } from '@/api/saleManage/contact';

  import {
    getSaleOrderDetail,
    UpdateInformation,
    addInformation,
    submit
  } from '@/api/saleManage/saleorder';
  import { getcontactlink } from '@/api/saleManage/businessFollow';
  import headList from '@/BIZComponents/user-select/user-select.vue';
  import contractListDialog from './contractListDialog.vue';
  import projectListDialog from './projectListDialog.vue';

  import paymentList from './paymentList.vue';
  import { listOrganizations } from '@/api/system/organization';
  import { copyObj } from '@/utils/util';
  import { enterprisePage } from '@/api/contractManage/contractBook';
  import fileMain from '@/components/addDoc/index.vue';
  import processSubmitDialog from '@/BIZComponents/processSubmitDialog/processSubmitDialog.vue';
  import { getUserDetail } from '@/api/system/organization/index.js';
  import typeList from './typeList.vue';
  export default {
    mixins: [dictMixins],
    components: {
      processSubmitDialog,
      fileMain,
      fileUpload,
      headList,
      contractListDialog,
      projectListDialog,
      paymentList,
      inventoryTable,
      parentList,
      typeList
    },
    props: {
      contactData: {
        type: Object,
        default: () => {
          return {};
        }
      }
    },
    data() {
      let formDef = {
        id: '',
        contractId: '',
        orderFiles: [],
        contractName: '',
        projectName: '',
        projectId: '',
        pricingWay: 1,
        payAmount: '',
        generatePurchase: 0,
        generateProduce: 0,
        generateProject: 0,
        projectName: '',
        projectId: '',
        receiveAddress: '',
        remark: '',
        saleType: '',
        saleTypeName: '',
        totalAmount: 0,
        settlementMode: '4',
        settlementModeName: '分期付款',
        partaUnifiedSocialCreditCode: '',
        partbUnifiedSocialCreditCode: '',
        partaAddress: '',
        partaEmail: '',
        partaFax: '',
        partaId: '',
        partaLinkId: '',
        partaLinkName: '',
        partaName: '',
        partaTel: '',
        partbAddress: '',
        partbEmail: '',
        partbFax: '',
        partbId: '',
        partbLinkId: '',
        partbLinkName: '',
        partbName: '',
        partbTel: '',
        needProduce: 1,
        planNumUnit: '立方'
      };

      return {
        customerMark: '',
        projectData: {}, //项目数据
        clearing: false, //是否清除合同
        processSubmitDialogFlag: false,
        fullscreen: false, //全屏
        linkNameOptions: [],
        cacheKeyUrl: 'eos-saleManage-saleOrder-inventoryTable',
        visible: false,
        title: '',
        formDef,
        form: copyObj(formDef),
        tableLinkData: [],
        // 组织机构树形结构数据
        groupTreeData: [],
        groupData: [],
        rules: {
          settlementMode: [
            { required: true, message: '请选择结算方式', trigger: 'change' }
          ],

          saleType: [
            { required: true, message: '请选择销售类型', trigger: 'change' }
          ],

          partaName: [
            { required: true, message: '请选择客户名称', trigger: 'change' }
          ],
          partaLinkName: [
            { required: true, message: '请选择客户联系人', trigger: 'change' }
          ],
          acceptUnpack: [
            { required: true, message: '请选择是否接受', trigger: 'change' }
          ],
          partaTel: [
            {
              required: true,
              pattern: telReg,
              message: '请输入客户联系电话',
              trigger: 'blur'
            }
          ],

          partbName: [
            { required: true, message: '请输入售出方名称', trigger: 'change' }
          ],
          partbLinkName: [
            { required: true, message: '请输入售出方联系人', trigger: 'change' }
          ],
          partbTel: [
            {
              required: true,
              pattern: telReg,
              message: '请输入售出方联系电话',
              trigger: 'blur'
            }
          ],
          partaEmail: [
            { pattern: emailReg, message: '邮箱格式不正确', trigger: 'blur' }
          ],
          payAmount: [{ required: true, message: '请输入', trigger: 'blur' }]
        },
        // 提交状态
        loading: false,
        // 是否是修改
        isUpdate: false,
        enterprisePage: [],
        businessId: ''
      };
    },
    computed: {
      clientEnvironmentId() {
        return this.$store.state.user.info.clientEnvironmentId;
      }
    },
    created() {
      this.changePersonel();
      this.getGroupAll();
      this.getEnterprisePage();
    },
    methods: {
      setCountAmount(allPrice) {
        this.form.totalAmount = allPrice;
        this.form.payAmount = allPrice;
      },
      setTotalPlanNum(totalPlanNum) {
        this.$set(this.form, 'totalPlanNum', totalPlanNum);
      },
      discountInput() {
        this.$refs.inventoryTable.discountInputByOrder(this.form.payAmount);
      },
      // 选择负责人部门
      change_principalDep(id) {
        const info = this.groupData.find((e) => e.id == id);
        this.form.salesDeptName = info.name;
      },
      // 获取公司数据
      getGroupAll() {
        listOrganizations().then((list) => {
          this.groupData = list;
          this.groupTreeData = this.$util.toTreeData({
            data: list,
            idField: 'id',
            parentIdField: 'parentId'
          });
        });
      },

      //选择合同获取合同的详情
      async getDetailData(id) {
        this.loading = true;
        const data = await getDetail(id);
        this.loading = false;
        if (data) {
          await this.changeParent({ id: data.contractVO?.partaId }, true);
          this.$nextTick(() => {
            let { contractVO } = data;
            let {
              partaAddress,
              partaEmail,
              partaFax,
              partaId,
              partaLinkId,
              partaLinkName,
              partaName,
              partaTel,
              partbAddress,
              partbEmail,
              partbFax,
              partbId,
              partbLinkId,
              partbLinkName,
              partbName,
              partbTel,
              totalPrice,
              discountTotalPrice,
              partaUnifiedSocialCreditCode,
              partbUnifiedSocialCreditCode,
              settlementMode,
              settlementModeName,
              pricingWay,
              contractNo,
              contractNumber
            } = contractVO;
            this.form = Object.assign({}, this.form, {
              partaAddress,
              partaEmail,
              partaFax,
              partaId,
              partaLinkId,
              partaLinkName,
              partaName,
              partaTel,
              partbAddress,
              partbEmail,
              partbFax,
              partbId,
              partbLinkId,
              partbLinkName,
              partbName,
              partbTel,
              pricingWay,
              totalPrice,
              discountTotalPrice,
              partaUnifiedSocialCreditCode,
              partbUnifiedSocialCreditCode,
              totalAmount: totalPrice,
              payAmount: discountTotalPrice || totalPrice,
              receiveAddress: partaAddress,
              settlementMode,
              settlementModeName,
              contractNo,
              contractNumber
            });
            this.getLinkInfo(partaId);
            this.$refs.inventoryTable &&
              this.$refs.inventoryTable.putTableValue(data);
          });
        }
      },

      //获取订单详情
      async getSaleOrderDetail(id) {
        this.businessId = id;
        this.loading = true;
        const data = await getSaleOrderDetail(id);
        this.loading = false;
        this.form = data;
        if (data.partaId) {
          await this.changeParent({ id: data.partaId }, true);
        }

        if (data) {
          data.saleType = +data.saleType;
          this.$nextTick(() => {
            this.$refs.inventoryTable &&
              this.$refs.inventoryTable.putTableValue(data);
            this.$refs.typeListRef &&
              this.$refs.typeListRef.putTableValue(data.typedetailList);

            this.getLinkInfo(data.partaId);
            this.$store.commit('order/setContractId', data.partaId);
          });
        }
      },

      //更新联系人数据
      async getLinkInfo(contactId) {
        const data = await getcontactlink({ contactId });
        if (data && data?.length) {
          this.linkNameOptions = data;
        }
      },
      selectFocus() {
        if (this.linkNameOptions.length === 0) {
          return this.$message.error('请先选择名称');
        }
      },

      //选择下拉框
      onchangeLink(selectedOptions) {
        const option = this.linkNameOptions.find(
          (opt) => opt.id === selectedOptions
        );
        this.form = Object.assign({}, this.form, {
          partaEmail: option?.email,
          partaLinkName: option?.linkName || '',
          partaTel: option?.mobilePhone || option?.phone || '',
          partaLinkId: option?.id
        });
      },

      handHead() {
        let item = {
          id: this.form.partbLinkId
        };
        this.$refs.headRef.open(item);
      },

      //选择售出方人回调
      changePersonel(obj) {
        if (!obj) {
          obj = this.$store.getters.user.info;
          obj.id = obj.userId;
        }
        this.$set(this.form, 'partbLinkId', obj.id);
        this.$set(this.form, 'partbLinkName', obj.name);
        this.$set(this.form, 'partbTel', obj.phone);
        this.$set(this.form, 'partbEmail', obj.email);
      },
      //选择客户回调
      async changeParent(obj, isCustomerMark) {
        const { base, other } = await contactDetail(obj.id);
        const userInfo = base?.salesmanId
          ? await getUserDetail(base.salesmanId)
          : {};

        this.customerMark = base.serialNo;
        if (isCustomerMark) {
          return;
        }
        this.form = Object.assign({}, this.form, {
          partaId: base.id,
          partaName: base.name,
          partaAddress: other.addressName + other.address,
          partaLinkId: '',
          partaLinkName: '',
          partaEmail: '',
          partaTel: '',
          partaUnifiedSocialCreditCode: base.unifiedSocialCreditCode,
          customerMark: base.serialNo,
          receiveAddress: other.addressName + other.address
        });
        this.changePersonel(userInfo?.id ? userInfo : '');

        await this.getLinkInfo(obj.id);
        this.$nextTick(() => {
          let firstLink =
            this.linkNameOptions.find((item) => item.ifChief == 1) || {};
          this.form = Object.assign({}, this.form, {
            partaLinkId: firstLink.id || this.linkNameOptions[0]?.id,
            partaLinkName:
              firstLink.linkName || this.linkNameOptions[0]?.linkName,
            partaTel:
              firstLink.mobilePhone || this.linkNameOptions[0]?.mobilePhone
          });
          this.setProductInfo();
        });
      },
      setProductInfo() {
        if (this.$refs.inventoryTable && this.$refs.inventoryTable.form) {
          this.$refs.inventoryTable?.form?.datasource.forEach((item, index) => {
            this.$set(
              this.$refs.inventoryTable?.form?.datasource[index],
              'customerMark',
              this.customerMark
            );
          });
        }
      },
      //选择合同回调
      changeContract(obj) {
        this.form = Object.assign({}, this.form, {
          contractId: obj.id,
          contractName: obj.contractName
        });
        this.getDetailData(obj.id);
        this.$store.commit('order/setContractId', obj.id);
      },

      //选择合同弹框
      handleContractBtn() {
        if (this.clearing) return;
        let item = {
          id: this.form.contractId
        };
        this.$refs.selectContractRef.open(item);
      },
      //选择项目回调
      async changeProject(obj) {
        this.projectData = obj;
        this.form = Object.assign({}, this.form, {
          projectName: obj.name,
          projectId: obj.id,
          projectCode: obj.code
        });

        if (obj.contractId) {
          this.changeContract({
            id: obj.contractId,
            contractName: obj.contractName
          });
        } else if (obj.contactId) {
          this.changeParent({ id: obj.contactId });
        }
      },
      //选择项目弹框
      handleProjectBtn() {
        if (this.clearing) return;
        let item = {
          id: this.form.projectId
        };
        this.$refs.selectProjectRef.open(item);
      },

      //清除合同
      clearContrcat() {
        this.clearing = true;
        let {
          id,
          saleType,
          saleTypeName,
          // deliveryDate,
          orderFiles,
          remark
        } = this.form;
        this.form = Object.assign({}, copyObj(this.formDef), {
          id,
          saleType,
          saleTypeName,
          // deliveryDate,
          orderFiles,
          remark
        });
        this.projectData = {};

        this.$store.commit('order/setContractId', '');
        this.$refs.inventoryTable.putTableValue([]);

        setTimeout(() => {
          this.clearing = false;
        }, 500);
      },

      handParent() {
        if (this.form.contractId) {
          return this.$message.error('选择了合同不能更改客户名称');
        }
        let item = {
          id: this.form.contactId
        };
        this.$refs.parentRef.open(item);
      },
      listFormatte(data) {
        return data.filter((item) => item.dictCode !== 0);
      },

      //打开新增编辑弹框
      async open(type, row, contactCategoryId) {
        this.title = type === 'add' ? '新增' : '修改';
        this.row = row;
        if (this.enterprisePage.length == 0) {
          await this.getEnterprisePage();
        }
        this.visible = true;
        if (type == 'add') {
          this.isUpdate = false;
          if (this.enterprisePage.length > 0) {
            this.form.partbName = this.enterprisePage[0].name;
            this.form.partbUnifiedSocialCreditCode =
              this.enterprisePage[0].unifiedSocialCreditCode;
            this.form.partbFax = this.enterprisePage[0].fax;
            this.form.partbAddress = this.enterprisePage[0].address;
          }
          if (this.contactData.id) {
            this.changeParent({ id: this.contactData.id });
          }
          //嘉实默认值
          if (this.clientEnvironmentId == 5) {
            this.form.saleType = 2;
            this.form.needProduce = 0;
            this.form.settlementMode = '6';
          }
          //宝悦默认值
          if (this.clientEnvironmentId == 4) {
            this.form.needProduce = 4;
          }
        } else {
          this.isUpdate = true;
          this.getSaleOrderDetail(row.id);
        }
      },
      needProduceChange(needProduce) {
        this.$nextTick(() => {
          this.form.totalAmount = 0;
          this.form.payAmount = 0;
        });
      },

      //从合同页面新增订单
      async contractOpen(row) {
        this.title = '新增';
        this.visible = true;
        this.isUpdate = false;
        if (this.enterprisePage.length == 0) {
          await this.getEnterprisePage();
        }
        if (this.enterprisePage.length > 0) {
          this.form.partbName = this.enterprisePage[0].name;
          this.form.partbUnifiedSocialCreditCode =
            this.enterprisePage[0].unifiedSocialCreditCode;
          this.form.partbFax = this.enterprisePage[0].fax;
          this.form.partbAddress = this.enterprisePage[0].address;
        }
        await this.changeContract(row);
      },
      getEnterprisePage() {
        enterprisePage({
          pageNum: 1,
          size: 100
        }).then((res) => {
          this.enterprisePage = [];
          this.enterprisePage.push(...res.list);
        });
      },
      getEnterprise() {
        let data = this.enterprisePage.find(
          (item) => item.name == this.form.quoteName
        );
        this.form.partbName = data.name;
        this.form.partbUnifiedSocialCreditCode = data.unifiedSocialCreditCode;
        this.form.partbFax = data.fax;
        this.form.partbAddress = data.address;
      },

      settlementModeChange(info) {
        this.form.settlementModeName = info.dictValue;
      },
      ifChiefChange(value, idx) {
        if (value === 1) {
          this.tableLinkData.forEach((e) => (e.ifChief = 0));
          this.tableLinkData[idx].ifChief = 1;
        }
      },

      getValidate() {
        let arr = [
          new Promise((resolve, reject) => {
            this.$refs.form.validate((valid) => {
              if (!valid) {
                reject(false);
              } else {
                resolve(true);
              }
            });
          })
        ];
        if (this.form.needProduce != 4) {
          arr.push(
            new Promise((resolve, reject) => {
              this.$refs.inventoryTable.validateForm((valid) => {
                if (!valid) {
                  reject(false);
                } else {
                  resolve(true);
                }
              });
            })
          );
        }

        return Promise.all(arr);
      },
      async save(type) {
        try {
          await this.getValidate();
          // 表单验证通过，执行保存操作
          this.loading = true;
          let isTemporary = [];

          if (!this.isUpdate) {
            delete this.form.id;
          }

          let commitData = Object.assign({}, this.form, {
            productList: this.$refs?.inventoryTable?.getTableValue() || [],
            typedetailList: this.$refs?.typeListRef?.getTableValue() || [],
            saleTypeName: this.getDictValue('销售类型', this.form.saleType)
          });
          commitData.productList.forEach((item) => {
            if (!item.productCode) {
              isTemporary.push(item.productName);
            }
          });
          if (isTemporary.length > 0) {
            this.$message.error(
              isTemporary.toString() +
                '是临时产品，无法创建订单，请先去主数据维护！'
            );

            return;
          }
          this.interfaceCall(commitData, type);
        } catch (error) {
          console.log(error);
          // 表单验证未通过，不执行保存操作
        }
      },

      interfaceCall(commitData, type) {
        let API = this.isUpdate ? UpdateInformation : addInformation;
        API(commitData)
          .then((res) => {
            this.loading = false;
            updateRelationStatus([this.form.partaId]);
            if (this.form.contractId) {
              updateContractStatus([this.form.contractId]);
            }
            if (type === 'sub') {
              this.saleOrderSubmit(res, commitData);
              return;
            } else {
              this.$message.success('操作成功');
            }
            this.cancel();
            this.$emit('done');
          })
          .catch((e) => {
            //this.loading = false;
          });
      },
      async saleOrderSubmit(res, commitData) {
        const data = await getSaleOrderDetail(this.businessId || res);
        this.processSubmitDialogFlag = true;
        let businessType =
          data.needProduce == 1
            ? '有客户生产性订单'
            : data.needProduce == 2
            ? '无客户生产性订单'
            : data.needProduce == 4
            ? '不定向订单'
            : '库存式订单';
        this.$nextTick(() => {
          let params = {
            businessId: data.id,
            businessKey: 'sales_order_approve',
            formCreateUserId: data.createUserId,
            variables: {
              businessCode: data.orderNo,
              businessName: data.partaName,
              businessType: businessType
            }
          };
          this.$refs.processSubmitDialogRef.init(params);
        });
      },
      reload() {
        this.cancel();
        this.$emit('done');
      },
      cancel() {
        this.$nextTick(() => {
          // 关闭后，销毁所有的表单数据
          this.$refs['otherForm'] && this.$refs['otherForm'].resetFields();
          this.$refs['formRef'] && this.$refs['formRef'].resetFields();
          this.$store.commit('order/clearUserData');
          this.form = copyObj(this.formDef);
          this.visible = false;
          this.projectData = {};
        });
      },
      //查找合同分类对应name
      findNameById(tree, targetId) {
        for (let i = 0; i < tree.length; i++) {
          const node = tree[i];
          if (node.id === targetId) {
            return node.name;
          }
          if (node.children && node.children.length > 0) {
            const name = this.findNameById(node.children, targetId);
            if (name) {
              return name;
            }
          }
        }
        return null;
      }
    }
  };
</script>
<style scoped lang="scss">
  .TotalAmount {
    font-size: 16px;
    padding-right: 30px;
  }
  .totalPlanNum {
    :deep(.el-input-group__append) {
      width: 160px;
    }
  }
</style>
